# Elastic

Elastic leverages the powerful features of the Dart programming language and
fuses them with functional concepts to provide a lightweight fabric for building
fast and performant web applications.

## Example

Using the Elastic application interface, you can get your web application up and
running in no time. Here's a simple example.

```dart
import 'dart:async';

import 'lib/elastic.dart';

class Example extends Middleware {
  @override
  Future<Context> resolve(Context context, Resolver next) async => context
    .setResponse(Response.text('Hello, Elastic!'));
}

Future main() async => listen(middleware: [
  Example()
]);
```

To run this example, simply paste the code into a file and let the Dart SDK
evaluate it. You should then be able to fire up your favorite browser and
navigate to `localhost:9000` to see the example application in action.
